var CarsGroupsWindow;// окно, содержащее список групп магазинов

function showCarsGroupsWindow(){
    
	Data_Cars.load();
	Data_CarsUsers.load();
	
	Ext.define('CarsGroups', {
    extend: 'Ext.data.Model',
    fields: [ 'id','name', 'description']
	});


    var Data_CarsGroups = new Ext.data.Store({
        model: 'CarsGroups',
           proxy: {
              type: 'ajax',
              url: 'scripts/Catalogs_CarsGroups.php?func=show',
              reader: {
                  type: 'json',
                  root: 'rows'
              },
          }
	});
    Data_CarsGroups.load();
	
	var CarsGroupsGrid = new Ext.grid.GridPanel({
    renderTo: Ext.getBody(),
    selType: 'rowmodel',
    //plugins: [rowEditing_CarsGroups],
    id: 'CarsGroups_grid',
    store:Data_CarsGroups,
    columns : [
     {
            text : 'ID', 
            dataIndex : 'id',
            width:Style.Grid.id_Width,
            sortable: true,
            hideable: false,
            id:'id_cgr'
            
        },
        {
            text : 'Название', 
            dataIndex : 'name',
            width:100,
            sortable: true,
            hideable: false,
            id:'name_cgr',
            editor: 'textfield'
            
        },
        {
            text : 'Описание',
            dataIndex: 'description',
            width:100,
            sortable: true,
            hideable: false,
            id:'description_cgr',
            editor: 'textfield'
           
        }/*,
        {
            text : 'Список машин',
            dataIndex: 'list',
            width:100,
            sortable: true,
            hideable: false,
            id:'list_cgr',
            editor: 'textfield'
           
        }*/      
        ],
        tbar: [
        
        {
            text   : "Добавить",
            handler: function() {
                showCarsGroupsWindow_add();
         }
            
        },
        '-',
        {
            text: 'Удалить',
            handler: function() {
                var sm = CarsGroupsGrid.getSelectionModel().getSelection()
                if (sm[0]!=undefined)
                {
                    Ext.MessageBox.confirm('Удаление','Вы действительно хотите удалить эту группу',function showRes(btn){
						if(btn=='yes'){
							showCarsGroupsWindow_delete(sm);
						}
					})
                }
                else {alert('Выберите хотя бы одну строку');}
            }
        },
        '-',
        {
            text   : "Редактировать",
            handler: function()
            {
                 var sm = CarsGroupsGrid.getSelectionModel().getSelection()
                 if (sm[0]!=undefined)
                 {
                    showCarsGroupsWindow_update(sm[0].get('id'));
                 }
                else {alert('Выберите хотя бы одну строку');}
                    
            }
           
        }
        ],
		listeners:{
			itemdblclick: function(View,record,item,index,e,eOpts){
				showCarsGroupsWindow_update(record.get('id'));
			}
		}
                
	});
	
	
	if (!CarsGroupsWindow){
        Ext.getBody().mask('Обработка...');
        CarsGroupsWindow = new Ext.Window({
            layout : 'fit', 
            title : 'Группы автомобилей',
            closeAction : 'hide',
            width : 550,
            height : 400,
            //minimizable: true,
            maximizable:true,
            x : 40,
            y : 60,
			//html: CarsGroupsGrid,
            listeners : {
                hide : function(){
                    CarsGroupsWindow = 0; 
                }
            },
            items : [CarsGroupsGrid]
        });
        CarsGroupsWindow.show();
        Ext.getBody().unmask('Обработка...');    
    }
}




   
   
Ext.define('Cars', {
    extend: 'Ext.data.Model',
    fields: [ 'id','name']
});


      var Data_Cars = new Ext.data.Store({
        model: 'Cars',
           proxy: {
              type: 'ajax',
              url: 'scripts/Catalogs_CarsGroups.php?func=get_cars',
              reader: {
                  type: 'json',
                  root: 'rows'
              },
           sortInfo: {
            field: 'name',
            direction: 'ASC'
          }
          }
   });
   
   
  
  var Data_CarsUsers = new Ext.data.Store({
        model: 'Cars',
           proxy: {
              type: 'ajax',
              url: 'scripts/Catalogs_CarsGroups.php?func=get_carsusers',
              reader: {
                  type: 'json',
                  root: 'rows'
              },
           sortInfo: {
            field: 'name',
            direction: 'ASC'
          }
          }
   });
  
        
/*var rowEditing_CarsGroups = Ext.create('Ext.grid.plugin.RowEditing', {
    clicksToMoveEditor: 1,
    autoCancel: false
});*/



function showCarsGroupsWindow_update(groupId) 
{
     /* var Data_Cars = new Ext.data.Store({
        model: 'Cars',
           proxy: {
              type: 'ajax',
              url: 'scripts/Catalogs_CarsGroups.php?func=get_cars_update&GroupId=' + groupId,
              reader: {
                  type: 'json',
                  root: 'rows'
              },
           sortInfo: {
            field: 'name',
            direction: 'ASC'
          }
          }
   });
   
   Data_Cars.load(); */
    $.post("scripts/Catalogs_CarsGroups.php",{func:'get_cars_update',GroupId:groupId}, function(data)
    {
    var arrObj = data.split("/t");
	var storeOut = eval('(' + arrObj[0] + ')');
    var storeIn = eval('(' + arrObj[1] + ')');
	var nG = arrObj[2];
	var dG = arrObj[3];
	var storeIn2 = eval('(' + arrObj[4] + ')');
	 
     if(!CarsGroups_win_update){
         var CarsGroups_win_update = new Ext.Window({
                        width:500,
                        height:500,
                        title: 'Редактирование группы',
                         closeAction : 'destroy',
                        layout:'fit',
                        resizable:false,
                        modal:true,
                        bodyStyle:{'background-color': '#FFFFFF'},
                        items:[{
                      xtype: 'form',
                      bodyStyle: {padding: '20px'},
                     // fieldwidth:'width:150px',
                      items:[
                      {
                            xtype:'displayfield',
                            style:'margin-bottom:15px;',              
                            value:'Поля отмечены <b style="color:red">*</b> обязательные для заполнения'
                      },
                      {
                         xtype:'textfield',              
                         fieldLabel:'Название группы <b style="color:red">*</b>',
                         id:'name_car_group_update',
                         labelAlign: Style.Input.LabelAlign,
                         labelStyle: Style.Input.LabelStyle,
                         style:Style.Input.StyleLeft,
                         width:Style.Input.Width,
						 value: nG
                      },
                       {
                         xtype:'textfield',              
                         fieldLabel:'Описание группы',
                         id:'description_car_group_update',
                         labelAlign: Style.Input.LabelAlign,
                         labelStyle: Style.Input.LabelStyle,
                         style:Style.Input.StyleRight,
                         width:Style.Input.Width,
						 value: dG
                      },
        {
            xtype: 'itemselector',
            height:150,
            id:'carsgroups_itemselector_update',
            buttons :['add', 'remove'],
            buttonsText : {add: "Добавить в группу", remove: "Удалить из группы"},
            fromTitle: 'Машины',
            toTitle: 'Группа',
            validateOnChange:false,
            autoScroll:true,
            imagePath: '../ux/images/',
            store: Data_Cars,
            displayField: 'name',
            valueField: 'id',
            value : storeIn,
            allowBlank: false,
            msgTarget: 'side'
        },
		{
            xtype: 'itemselector',
            height:150,
            id:'carsgroupsusers_itemselector_update',
            buttons :['add', 'remove'],
            buttonsText : {add: "Добавить в группу", remove: "Удалить из группы"},
            fromTitle: 'Пользователи',
            toTitle: 'Группа',
            validateOnChange:false,
            autoScroll:true,
            imagePath: '../ux/images/',
            store: Data_CarsUsers,
            displayField: 'name',
            valueField: 'id',
			value : storeIn2,
            allowBlank: false,
            msgTarget: 'side'
        }],
                        buttons:[{              // Кнопки окна
                                text:'Сохранить',
                                id:'buttonOK',
                                 handler: function() {
                                               var item_cargroup=Ext.getCmp('carsgroups_itemselector_update').getValue();
											   var item_cargroupusers=Ext.getCmp('carsgroupsusers_itemselector_update').getValue();
                                               var name_group=Ext.getCmp('name_car_group_update').getValue();
                                               var description_group=Ext.getCmp('description_car_group_update').getValue();
                                               if (name_group=='') {alert('Заполните все поля обязательные для заполнения');}
                                               else
                                               {
                                               if (item_cargroup==''){alert('Группа не может быть пустой!');} 
                                               else
                                               {
                                               $.post("scripts/Catalogs_CarsGroups.php",{func:'update_group',groupId:groupId,'item_cargroup[]':item_cargroup,'item_cargroupusers[]':item_cargroupusers,name_group:name_group,description_group:description_group}, function(data){
                                                  //alert(data);
												  
                                                  //CarsGroupsGrid.store.load();
                                                  //CarsGroupsGrid.getView().refresh();
												  Ext.getCmp('CarsGroups_grid').store.load();
												  Ext.getCmp('CarsGroups_grid').getView().refresh();
												  CarsGroups_win_update.destroy();
                                                } );
                                               }
                                               }
                                                
                                 }
                                },
                                {              // Кнопки окна
                                text:'Отмена',
                                id:'buttonCancel',
                                handler:function(){
                                        CarsGroups_win_update.destroy();        
                                           }

                                }]
                        }]

                })      
     }  
    CarsGroups_win_update.show();
   });                   
}






function showCarsGroupsWindow_add()
{ 
        if(!CarsGroups_win_add){
         var CarsGroups_win_add = new Ext.Window({
                        width:500,
                        height:500,
                        title: 'Создание новой группы',
                         closeAction : 'destroy',
                        layout:'fit',
                        resizable:false,
                        modal:true,
                        bodyStyle:{'background-color': '#FFFFFF'},
                        items:[{
                      xtype: 'form',
                      bodyStyle: {padding: '20px'},
                     // fieldwidth:'width:150px',
                      items:[
                       {
                            xtype:'displayfield',
                            style:'margin-bottom:15px;',              
                            value:'Поля отмечены <b style="color:red">*</b> обязательные для заполнения'
                       },
                      {
                         xtype:'textfield',              
                         fieldLabel:'Название группы <b style="color:red">*</b>',
                         id:'name_car_group_add',
                         labelAlign: Style.Input.LabelAlign,
                         labelStyle: Style.Input.LabelStyle,
                         style:Style.Input.StyleLeft,
                         width:Style.Input.Width 
                      },
                       {
                         xtype:'textfield',              
                         fieldLabel:'Описание группы',
                         id:'description_car_group_add',
                         labelAlign: Style.Input.LabelAlign,
                         labelStyle: Style.Input.LabelStyle,
                         style:Style.Input.StyleRight,
                         width:Style.Input.Width 
                      },
        {
            xtype: 'itemselector',
            height:150,
            id:'carsgroups_itemselector_add',
            buttons :['add', 'remove'],
            buttonsText : {add: "Добавить в группу", remove: "Удалить из группы"},
            fromTitle: 'Машины',
            toTitle: 'Группа',
            validateOnChange:false,
            autoScroll:true,
            imagePath: '../ux/images/',
            store: Data_Cars,
            displayField: 'name',
            valueField: 'id',
            allowBlank: false,
            msgTarget: 'side'
        },
		{
            xtype: 'itemselector',
            height:150,
            id:'carsgroupsusers_itemselector_add',
            buttons :['add', 'remove'],
            buttonsText : {add: "Добавить в группу", remove: "Удалить из группы"},
            fromTitle: 'Пользователи',
            toTitle: 'Группа',
            validateOnChange:false,
            autoScroll:true,
            imagePath: '../ux/images/',
            store: Data_CarsUsers,
            displayField: 'name',
            valueField: 'id',
            allowBlank: false,
            msgTarget: 'side'
        }],
                        buttons:[{              // Кнопки окна
                                text:'Сохранить',
                                id:'buttonOK',
                                 handler: function() {
                                               var item_cargroup=Ext.getCmp('carsgroups_itemselector_add').getValue();
											   var item_cargroupusers=Ext.getCmp('carsgroupsusers_itemselector_add').getValue();
                                               
											   var name_group=Ext.getCmp('name_car_group_add').getValue();
                                               var description_group=Ext.getCmp('description_car_group_add').getValue();
                                               if (name_group=='') {alert('Заполните все поля обязательные для заполнения');}
                                               else
                                               {
                                               if (item_cargroup==''){alert('Группа не может быть пустой!');} 
                                               else
                                               {
                                               $.post("scripts/Catalogs_CarsGroups.php",{func:'save_group','item_cargroup[]':item_cargroup,'item_cargroupusers[]':item_cargroupusers,name_group:name_group,description_group:description_group}, function(data){
                                                  //alert(data);
                                                  //CarsGroupsGrid.store.load();
                                                  //CarsGroupsGrid.getView().refresh();
												   Ext.getCmp('CarsGroups_grid').store.load();
												  Ext.getCmp('CarsGroups_grid').getView().refresh();
												  CarsGroups_win_add.destroy();
                                                } );
                                               }
                                               }
                                                
                                 }
                                },
                                {              // Кнопки окна
                                text:'Отмена',
                                id:'buttonCancel',
                                handler:function(){
                                        CarsGroups_win_add.destroy();        
                                           }

                                }]
                        }]

                })      
     }  
    CarsGroups_win_add.show();
  // });
}

/*function showCarsGroupsWindow_delete(sm){
        if(!CarsGroups_win_delete){
                var CarsGroups_win_delete = new Ext.Window({
                        width:300,
                        height:150,
                        title: 'Удаление данных',
                        html:'<h1>Вы точно хотете удалить данную строку!?</h2>',
                        modal:true,
                        layout:'fit',
                        bodyStyle:{'background-color': '#FFFFFF'},
                        buttons:[{              // Кнопки окна
                                text:'Да',
                                id:'buttonOK',
                                 handler: function() {
                                                $.post("scripts/Catalogs_CarsGroups.php",{func:'delete',id:sm[0].get('id')},function(data)
                                                {
                                                    CarsGroupsGrid.store.load(data);
                                                    CarsGroupsGrid.getView().refresh();
                                                    CarsGroups_win_delete.destroy(); 
                                                
                                                });                                              
                                 }
                                },
                                {              // Кнопки окна
                                text:'Нет',
                                id:'buttonCancel',
                                handler:function(){
                                        CarsGroups_win_delete.destroy();        
                                           }

                                }]

                })      
        }
        CarsGroups_win_delete.show();
}*/
function showCarsGroupsWindow_delete(sm){
$.post("scripts/Catalogs_CarsGroups.php",{func:'delete',id:sm[0].get('id')},function(data){
    //CarsGroupsGrid.store.load(data);
    //CarsGroupsGrid.getView().refresh();
    Ext.getCmp('CarsGroups_grid').store.load();
	Ext.getCmp('CarsGroups_grid').getView().refresh();
	//CarsGroups_win_delete.destroy(); 
});
}



